// filter_hook.cpp
// ֐tbNp
// Copyright (c) 2008 N099
//
#include <windows.h>
#include <iostream>
#include <fstream>
#include <cstdio>
#include <ctime>
#include <intrin.h>

#include <hash_map>
#include <vector>
#include <algorithm>

#include "filter_wrap.h"
#include "filter_hook.h"

using namespace std;
using namespace stdext;

//Logging output
static ofstream logout;
static LARGE_INTEGER refclk;
static double nrmclk;
static char strbuf[512];

//ԕ\
ostream &clk(ostream &os)
{
	streamsize sz = os.width(10);
	char ch = os.fill('0');
	LARGE_INTEGER clk;
	QueryPerformanceCounter(&clk);
	_mm_empty();
	double tm = static_cast<double>(clk.QuadPart - refclk.QuadPart);
	tm = tm * nrmclk + 0.5;

	os << static_cast<long>(tm) << ": ";

	os.fill(ch);
	os.width(sz);
	return os;
}

ostream &clk0(ostream &os)
{
	LARGE_INTEGER frq;
	QueryPerformanceFrequency(&frq);
	_mm_empty();
	nrmclk = 1000000.0 / static_cast<double>(frq.QuadPart);
	os << "0000000000:[uSec] ";
	QueryPerformanceCounter(&refclk);
	return os;
}


//֐tbNǗNX
class FilterHook
{
private:
	typedef pair<void*, ATFWrap> ATF_Pair;
	hash_map<void*, ATFWrap> _map_atwrap;
	vector<ATFWrap*> _stack_proc;
	bool _in_hidden_msg; //\ȂbZ[W
	bool _wproc_flg; //FuncWndProc()FALSEԂ悤ɂ

public:
	FilterHook() : _in_hidden_msg(false), _wproc_flg(false) {}
	bool isHooked() const { return !_map_atwrap.empty(); }
	bool Append(ATFilter* af, int id);
	void Restore();
	void DispFilters(ostream& os);
	int GetStackSize() const { return _stack_proc.size(); }
	ATFWrap* GetStackTop() const
	{ return _stack_proc.empty() ? NULL : _stack_proc.back(); }
	bool SetWprocFlag(bool b)
	{ bool old = _wproc_flg; _wproc_flg = b; return old; }
	bool InHiddenMsg() const { return _in_hidden_msg; }
	void TestExFunc(const EXFUNC *ex);

private:
	//I[o[Chp֐
	static ATFFuncTable FuncTbl;
	static EXFUNC ExFuncTbl;
	static BOOL __cdecl FuncProc(void *fp, FILTER_PROC_INFO *fpip);
	static BOOL __cdecl FuncInit(void *fp);
	static BOOL __cdecl FuncExit(void *fp);
	static BOOL __cdecl FuncUpdate(void *fp, int n);
	static BOOL __cdecl FuncWndProc(HWND h, UINT m, WPARAM w, LPARAM l, void *e, void *f);
	static BOOL __cdecl FuncSaveStart(void *fp, int s, int e, void *editp);
	static BOOL __cdecl FuncSaveEnd(void *fp, void *editp);
	static BOOL __cdecl FuncIsSaveFrame(void *fp, void *editp, int sno, int frame, int fps, int eflg, int ires);
	static BOOL __cdecl FuncProjectLoad(void *fp, void *editp, void *dat, int size);
	static BOOL __cdecl FuncProjectSave(void *fp, void *editp, void *dat, int *size);
	static BOOL __cdecl FuncModifyTitle(void *fp, void *editp, int frame, LPSTR title, int max);
};

static FilterHook fhook;

bool FilterHook::Append(ATFilter* af, int id)
{
	_stack_proc.clear();

	//gid=-1
	if(id < 0){
		TestExFunc(af->exfunc);
		return true;
	}

	//ȊO͒ǉ
	pair< hash_map<void*, ATFWrap>::iterator, bool > pr;
	pr = _map_atwrap.insert( ATF_Pair(af, ATFWrap(af, id)) );
	if(pr.second){
		pr.first->second.WrapFunc(&FuncTbl, &ExFuncTbl);
	}
	return pr.second;
}

void FilterHook::Restore()
{
	_stack_proc.clear();	

	while(!_map_atwrap.empty()){
		hash_map<void*, ATFWrap>::iterator iter = _map_atwrap.begin();
		iter->second.Restore();
		_map_atwrap.erase(iter);
	}
}

void FilterHook::DispFilters(ostream& os)
{
	vector<const ATFWrap*> atf_list;
	hash_map<void*, ATFWrap>::iterator iter = _map_atwrap.begin();
	for( ; iter != _map_atwrap.end(); ++iter){
		atf_list.push_back(&iter->second);
	}
	sort(atf_list.begin(), atf_list.end(), ATFWrap::LessPtr);

	os << clk << "Print Hooked Filters" << endl;
	vector<const ATFWrap*>::const_iterator cItr = atf_list.begin();
	for( ; cItr != atf_list.end(); ++cItr){
		(*cItr)->DispFilterInfo(os);
	}
	os.flush();
}

//LEXFUNCȊONULLɃZbg
void FilterHook::TestExFunc(const EXFUNC *ex)
{
	int i = 0;
	const int n = sizeof(ExFuncTbl)/sizeof(ExFuncTbl.get_ycp_ofs);
	const UINT_PTR *s = reinterpret_cast<const UINT_PTR *>(ex);
	UINT_PTR *d = reinterpret_cast<UINT_PTR*>(&ExFuncTbl);

	for( ; i<n; ++i){
		if(s[i] == NULL){
			d[i] = NULL;
			break;
		}
	}
	for( ; i<n; ++i) d[i] = NULL;
}

ostream &enter(ostream &os)
{
	int i;
	if(!fhook.InHiddenMsg()) os << "ENT>";
	else os << "ent";
	for(i=0; i<fhook.GetStackSize(); ++i) os << ">";
	os << " ";
	return os;
}

ostream &leave(ostream &os)
{
	int i;
	if(!fhook.InHiddenMsg()) os << "LEA<";
	else os << "lea";
	for(i=0; i<fhook.GetStackSize(); ++i) os << "<";
	os << " ";
	return os;
}

//J֐
BOOL ATHookAppend(FILTER *fp, int id)
{
	return fhook.Append(static_cast<ATFilter*>(fp), id) ? TRUE : FALSE;
}

BOOL ATIsHooked()
{
	return fhook.isHooked() ? TRUE : FALSE;
}

void ATHookRestore()
{
	fhook.Restore();
}

BOOL ATStartLogging()
{
	if(logout.is_open()) return FALSE;

	time_t tme;
	struct tm lt;
	time(&tme);
	localtime_s(&lt, &tme);
	
	sprintf_s(strbuf, sizeof(strbuf),
		"aft%04d_%02d%02d_%02d%02d%02d.log",
		lt.tm_year + 1900, lt.tm_mon + 1,
		lt.tm_mday, lt.tm_hour, lt.tm_min, lt.tm_sec);

	logout.open(strbuf);
	if(!logout){
		return FALSE;
	}

	logout << clk0 << "Start Logging. (" << strbuf << ")" << endl;
	fhook.SetWprocFlag(false);
	fhook.DispFilters(logout);

	return TRUE;
}

BOOL ATStopLogging()
{
	if(logout.is_open()){
		logout << clk << "Stop Logging." << endl;
		logout.close();
	}

	fhook.SetWprocFlag(false);
	return TRUE;
}

//tbNp֐
ATFFuncTable FilterHook::FuncTbl = {
	FuncProc,
	FuncInit,
	FuncExit,
	FuncUpdate,
	FuncWndProc,
	FuncSaveStart,
	FuncSaveEnd,
	FuncIsSaveFrame,
	FuncProjectLoad,
	FuncProjectSave,
	FuncModifyTitle
};

BOOL __cdecl FilterHook::FuncProc(void *fp, FILTER_PROC_INFO *fpip)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_proc(fp=0x%p,fpip=0x%p)", af->name, fp, fpip);
		logout << clk << enter << strbuf << " [frame:" << fpip->frame << "]" << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncProcOrig(fp, fpip);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_proc(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_proc(fp=0x%p,fpip=0x%p)", fp, fpip);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::FuncInit(void *fp)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_init(fp=0x%p)", af->name, fp);
		logout << clk << enter << strbuf << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncInitOrig(fp);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_init(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_init(fp=0x%p)", fp);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::FuncExit(void *fp)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_exit(fp=0x%p)", af->name, fp);
		logout << clk << enter << strbuf << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncExitOrig(fp);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_exit(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_exit(fp=0x%p)", fp);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::FuncUpdate(void *fp, int n)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_update(fp=0x%p,n=0x%08x) ", af->name, fp, n);
		logout << clk << enter << strbuf;
		if(n==0){
			logout << "ALL" << endl;
		}else if(n & FILTER_UPDATE_STATUS_TRACK){
			logout << "TRACK" << (n & ~FILTER_UPDATE_STATUS_TRACK) << endl;
		}else if(n & FILTER_UPDATE_STATUS_CHECK){
			logout << "CHECK" << (n & ~FILTER_UPDATE_STATUS_CHECK) << endl;
		}else{
			logout << "Pre0.99?" << endl;
		}

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncUpdateOrig(fp, n);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_update(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_update(fp=0x%p,n=0x%08x)", fp, n);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::
FuncWndProc(HWND h, UINT m, WPARAM w, LPARAM l, void *e, void *fp)
{
	BOOL ret = FALSE;
	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	bool thru = (m < WM_FILTER_UPDATE) || (m > WM_FILTER_CHANGE_EDIT);

	//ȊÕbZ[W͖
	if(thru){
		if(itr != fhook._map_atwrap.end()){
			fhook._in_hidden_msg = true;
			fhook._stack_proc.push_back(&itr->second);
			ret = itr->second.FuncWndProcOrig(h, m, w, l, e, fp);
			fhook._stack_proc.pop_back();
			fhook._in_hidden_msg = false;
		}
		return ret;
	}

	ATFilter *af = static_cast<ATFilter*>(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_WndProc(hwnd=%#x,"
			"msg=%#x,wp=%#x,lp=%#x,editp=0x%p,fp=0x%p) ",
			af->name, h, m, w, l, e, fp);
		logout << clk << enter << strbuf;
		af->PrintWndMsg(logout, m);

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncWndProcOrig(h, m, w, l, e, fp);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_WndProc(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}

	return fhook._wproc_flg ? FALSE : ret;
}

BOOL __cdecl FilterHook::FuncSaveStart(void *fp, int s, int e, void *editp)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_save_start(fp=0x%p,s=%d,e=%d,editp=0x%p)",
			af->name, fp, s, e, editp);
		logout << clk << enter << strbuf << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncSaveStartOrig(fp, s, e, editp);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_save_start(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_save_start(fp=0x%p,s=%d,e=%d,editp=0x%p)",
			fp, s, e, editp);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::FuncSaveEnd(void *fp, void *editp)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_save_end(fp=0x%p,editp=0x%p)", af->name, fp, editp);
		logout << clk << enter << strbuf << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncSaveEndOrig(fp, editp);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_save_end(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_save_end(fp=0x%p,editp=0x%p)", fp, editp);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::
FuncIsSaveFrame(void *fp, void *editp, int sno, int frame, int fps, int eflg, int ires)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_is_saveframe(fp=0x%p,editp=0x%p,saveno=%d,"
			"frame=%d,fps=%d,edit_flag=%#x,inter=%#x)",
			af->name, fp, editp, sno, frame, fps, eflg, ires);
		logout << clk << enter << strbuf << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncIsSaveFrameOrig(fp, editp, sno, frame, fps, eflg, ires);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_is_saveframe(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_is_saveframe(fp=0x%p,editp=0x%p,saveno=%d,"
			"frame=%d,fps=%d,edit_flag=%#x,inter=%#x)",
			fp, editp, sno, frame, fps, eflg, ires);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::FuncProjectLoad(void *fp, void *editp, void *dat, int size)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_project_load(fp=0x%p,editp=0x%p,data=0x%p,size=%d)",
			af->name, fp, editp, dat, size);
		logout << clk << enter << strbuf << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncProjectLoadOrig(fp, editp, dat, size);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_project_load(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_project_load(fp=0x%p,editp=0x%p,data=0x%p,size=%d)",
			fp, editp, dat, size);
		logout << clk << strbuf << endl;
	}

	return ret;
}

BOOL __cdecl FilterHook::FuncProjectSave(void *fp, void *editp, void *dat, int *size)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_project_save(fp=0x%p,editp=0x%p,data=0x%p,size=",
			af->name, fp, editp, dat);
		logout << clk << enter << strbuf;
		if(size){
			logout << *size << ")" << endl;
		}else{
			logout << "null)" << endl;
		}

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncProjectSaveOrig(fp, editp, dat, size);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_project_save(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_project_save(fp=0x%p,editp=0x%p,data=0x%p,size=",
			fp, editp, dat);
		logout << clk << strbuf;
		if(size){
			logout << *size << ")" << endl;
		}else{
			logout << "null)" << endl;
		}
	}

	return ret;
}

BOOL __cdecl FilterHook::
FuncModifyTitle(void *fp, void *editp, int frame, LPSTR title, int max)
{
	BOOL ret = FALSE;
	ATFilter *af = static_cast<ATFilter*>(fp);

	hash_map<void*, ATFWrap>::iterator itr = fhook._map_atwrap.find(fp);
	if(itr != fhook._map_atwrap.end()){
		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_modify_title(fp=0x%p,editp=0x%p,frame=%d,"
			"title=\"%s\",max_title=%d)", af->name, fp, editp, frame, title, max);
		logout << clk << enter << strbuf << endl;

		fhook._stack_proc.push_back(&itr->second);
		ret = itr->second.FuncModifyTitleOrig(fp, editp, frame, title, max);
		fhook._stack_proc.pop_back();

		sprintf_s(strbuf, sizeof(strbuf),
			"%s::func_modify_title(ret=%d)", af->name, ret);
		logout << clk << leave << strbuf << endl;
	}else{
		sprintf_s(strbuf, sizeof(strbuf),
			"FAILED!! func_modify_title(fp=0x%p,editp=0x%p,frame=%d,"
			"title=\"%s\",max_title=%d)", fp, editp, frame, title, max);
		logout << clk << strbuf << endl;
	}

	return ret;
}


//exfunc hook
void __cdecl get_ycp_ofs(void *editp, int n, int ofs)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_ycp_ofs){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_ycp_ofs(editp=0x%p,n=%d,ofs=%d)", af.name, editp, n, ofs);
			logout << clk << enter << strbuf << endl;

			af.exfunc->get_ycp_ofs(editp, n, ofs);

			sprintf_s(strbuf, sizeof(strbuf), "%s::EX get_ycp_ofs()");
			logout << clk << leave << strbuf << endl;
			return;
		}
	}
	
	logout << clk << "FAILED!! get_ycp_ofs()" << endl;
}

void * __cdecl get_ycp(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_ycp){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_ycp(editp=0x%p,n=%d)", af.name, editp, n);
			logout << clk << enter << strbuf << endl;

			void *ret = af.exfunc->get_ycp(editp, n);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_ycp(ret=0x%p)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! get_ycp()" << endl;
	return NULL;
}

void * __cdecl get_pixelp(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_pixelp){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_pixelp(editp=0x%p,n=%d)", af.name, editp, n);
			logout << clk << enter << strbuf << endl;

			void *ret = af.exfunc->get_pixelp(editp, n);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_pixelp(ret=0x%p)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! get_pixelp()" << endl;
	return NULL;
}

int __cdecl get_audio(void *editp, int n, void *buf)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_audio){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_audio(editp=0x%p,n=%d,buf=0x%p)",
				af.name, editp, n, buf);
			logout << clk << enter << strbuf << endl;

			int ret = af.exfunc->get_audio(editp, n, buf);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_audio(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! get_audio()" << endl;
	return 0;
}

BOOL __cdecl is_editing(void *editp)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->is_editing){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX is_editing(editp=0x%p)",
				af.name, editp);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->is_editing(editp);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX is_editing(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! is_editing()" << endl;
	return TRUE;
}

BOOL __cdecl is_saving(void *editp)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->is_saving){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX is_saving(editp=0x%p)",
				af.name, editp);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->is_saving(editp);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX is_saving(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! is_saving()" << endl;
	return FALSE;
}

int __cdecl get_frame(void *editp)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_frame){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame(editp=0x%p)",
				af.name, editp);
			logout << clk << enter << strbuf << endl;

			int ret = af.exfunc->get_frame(editp);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! get_frame()" << endl;
	return -1;
}

int __cdecl get_frame_n(void *editp)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_frame_n){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame_n(editp=0x%p)",
				af.name, editp);
			logout << clk << enter << strbuf << endl;

			int ret = af.exfunc->get_frame_n(editp);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame_n(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! get_frame_n()" << endl;
	return -1;
}

BOOL __cdecl get_frame_size(void *editp, int *w, int *h)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_frame_size){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame_size(editp=0x%p,*w=0x%p,*h=0x%p)",
				af.name, editp, w, h);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->get_frame_size(editp, w, h);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame_size(ret=%d,w=%d,h=%d)",
				af.name, ret, w ? *w : 0, h ? *h : 0);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! get_frame_size()" << endl;
	return FALSE;
}

int __cdecl set_frame(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->set_frame){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX set_frame(editp=0x%p,n=%d)", af.name, editp, n);
			logout << clk << enter << strbuf << endl;

			int ret = af.exfunc->set_frame(editp, n);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX set_frame(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! set_frame()" << endl;
	return -1;
}

int __cdecl set_frame_n(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->set_frame_n){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX set_frame_n(editp=0x%p,n=%d)", af.name, editp, n);
			logout << clk << enter << strbuf << endl;

			int ret = af.exfunc->set_frame_n(editp, n);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX set_frame_n(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! set_frame_n()" << endl;
	return -1;
}

BOOL __cdecl copy_frame(void *editp, int d, int s)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->copy_frame){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_frame(editp=0x%p,d=%d,s=%d)",
				af.name, editp, d, s);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->copy_frame(editp, d, s);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_frame(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}

	logout << clk << "FAILED!! copy_frame()" << endl;
	return FALSE;
}

BOOL __cdecl copy_video(void *editp, int d, int s)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->copy_video){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_video(editp=0x%p,d=%d,s=%d)",
				af.name, editp, d, s);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->copy_video(editp, d, s);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_video(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! copy_video()" << endl;
	return FALSE;
}

BOOL __cdecl copy_audio(void *editp, int d, int s)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->copy_audio){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_audio(editp=0x%p,d=%d,s=%d)",
				af.name, editp, d, s);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->copy_audio(editp, d, s);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_audio(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! copy_audio()" << endl;
	return FALSE;
}

BOOL __cdecl copy_clip(HWND hwnd, void *pixelp, int w, int h)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->copy_clip){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_clip(hwnd=%#x,pixelp=0x%p,w=%d,h=%d)",
				af.name, hwnd, pixelp, w, h);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->copy_clip(hwnd, pixelp, w, h);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX copy_clip(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! copy_clip()" << endl;
	return FALSE;
}

BOOL __cdecl paste_clip(HWND hwnd, void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->paste_clip){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX paste_clip(hwnd=%#x,editp=0x%p,n=%d)",
				af.name, hwnd, editp, n);
			logout << clk << enter << strbuf << endl;

			BOOL ret = af.exfunc->paste_clip(hwnd, editp, n);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX paste_clip(ret=%d)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! paste_clip()" << endl;
	return FALSE;
}

//ȉ蔲
BOOL __cdecl get_frame_status(void *editp, int n, FRAME_STATUS *fsp)
{
	ATFWrap* aw = fhook.GetStackTop();

	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_frame_status){
			logout << clk << enter << af.name
				<< "::EX get_frame_status()" << endl;

			BOOL ret = af.exfunc->get_frame_status(editp, n, fsp);

			logout << clk << leave << af.name 
				<< "::EX get_frame_status(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	
	logout << clk << "FAILED!! get_frame_status()" << endl;
	return FALSE;
}

BOOL __cdecl set_frame_status(void *editp, int n, FRAME_STATUS *fsp)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->set_frame_status){
			logout << clk << enter << af.name << "::EX set_frame_status()" << endl;
			BOOL ret = af.exfunc->set_frame_status(editp, n, fsp);
			logout << clk << leave << af.name << "::EX set_frame_status(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! set_frame_status()" << endl;
	return FALSE;
}

BOOL __cdecl is_saveframe(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->is_saveframe){
			logout << clk << enter << af.name << "::EX is_saveframe()" << endl;
			BOOL ret = af.exfunc->is_saveframe(editp, n);
			logout << clk << leave << af.name << "::EX is_saveframe(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! is_saveframe()" << endl;
	return TRUE;
}

BOOL __cdecl is_keyframe(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->is_keyframe){
			logout << clk << enter << af.name << "::EX is_keyframe()" << endl;
			BOOL ret = af.exfunc->is_keyframe(editp, n);
			logout << clk << leave << af.name << "::EX is_keyframe(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! is_keyframe()" << endl;
	return TRUE;
}

BOOL __cdecl is_recompress(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->is_recompress){
			logout << clk << enter << af.name << "::EX is_recompress()" << endl;
			BOOL ret = af.exfunc->is_recompress(editp, n);
			logout << clk << leave << af.name << "::EX is_recompress(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! is_recompress()" << endl;
	return FALSE;
}

BOOL __cdecl filter_window_update(void *fp)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->filter_window_update){
			logout << clk << enter << af.name << "::EX filter_window_update()" << endl;
			BOOL ret = af.exfunc->filter_window_update(fp);
			logout << clk << leave << af.name << "::EX filter_window_update(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX filter_window_update()" << endl;
	}else{
		logout << clk << "FAILED!! filter_window_update()" << endl;
	}
	return FALSE;
}

BOOL __cdecl is_filter_window_disp(void *fp)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->is_filter_window_disp){
			logout << clk << enter << af.name << "::EX is_filter_window_disp()" << endl;
			BOOL ret = af.exfunc->is_filter_window_disp(fp);
			logout << clk << leave << af.name << "::EX is_filter_window_disp(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX is_filter_window_disp()" << endl;
	}else{
		logout << clk << "FAILED!! is_filter_window_disp()" << endl;
	}
	return FALSE;
}

BOOL __cdecl get_file_info(void *editp, FILE_INFO *fip)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_file_info){
			logout << clk << enter << af.name << "::EX get_file_info()" << endl;
			BOOL ret = af.exfunc->get_file_info(editp, fip);
			logout << clk << leave << af.name << "::EX get_file_info(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_file_info()" << endl;
	return FALSE;
}

LPSTR __cdecl get_config_name(void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_config_name){
			logout << clk << enter << af.name << "::EX get_config_name()" << endl;
			LPSTR ret = af.exfunc->get_config_name(editp, n);
			logout << clk << leave << af.name << "::EX get_config_name(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_config_name()" << endl;
	return NULL;
}

BOOL __cdecl is_filter_active(void *fp)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->is_filter_active){
			logout << clk << enter << af.name << "::EX is_filter_active()" << endl;
			BOOL ret = af.exfunc->is_filter_active(fp);
			logout << clk << leave << af.name << "::EX is_filter_active(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX is_filter_active()" << endl;
	}else{
		logout << clk << "FAILED!! is_filter_active()" << endl;
	}
	return FALSE;
}

BOOL __cdecl get_pixel_filtered(void *editp, int n, void *pixelp, int *w, int *h)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_pixel_filtered){
			logout << clk << enter << af.name << "::EX get_pixel_filtered("
				"editp=0x" << editp << ",n=" << n << ")" << endl;
			BOOL ret = af.exfunc->get_pixel_filtered(editp, n, pixelp, w, h);
			logout << clk << leave << af.name << "::EX get_pixel_filtered(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_pixel_filtered()" << endl;
	return FALSE;
}

int __cdecl get_audio_filtered(void *editp, int n, void *buf)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_audio_filtered){
			logout << clk << enter << af.name << "::EX get_audio_filtered()" << endl;
			int ret = af.exfunc->get_audio_filtered(editp, n, buf);
			logout << clk << leave << af.name << "::EX get_audio_filtered(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_audio_filtered()" << endl;
	return 0;
}

BOOL __cdecl get_select_frame(void *editp, int *s, int *e)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_select_frame){
			logout << clk << enter << af.name << "::EX get_select_frame()" << endl;
			BOOL ret = af.exfunc->get_select_frame(editp, s, e);
			logout << clk << leave << af.name << "::EX get_select_frame(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_select_frame()" << endl;
	return FALSE;
}

BOOL __cdecl set_select_frame(void *editp, int s, int e)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->set_select_frame){
			logout << clk << enter << af.name << "::EX set_select_frame()" << endl;
			BOOL ret = af.exfunc->set_select_frame(editp, s, e);
			logout << clk << leave << af.name << "::EX set_select_frame(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! set_select_frame()" << endl;
	return FALSE;
}

BOOL __cdecl rgb2yc(PIXEL_YC *ycp, PIXEL *pixelp, int w)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->rgb2yc){
			logout << clk << enter << af.name << "::EX rgb2yc()" << endl;
			BOOL ret = af.exfunc->rgb2yc(ycp, pixelp, w);
			logout << clk << leave << af.name << "::EX rgb2yc(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! rgb2yc()" << endl;
	return FALSE;
}

BOOL __cdecl yc2rgb(PIXEL *pixelp, PIXEL_YC *ycp, int w)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->yc2rgb){
			logout << clk << enter << af.name << "::EX yc2rgb()" << endl;
			BOOL ret = af.exfunc->yc2rgb(pixelp, ycp, w);
			logout << clk << leave << af.name << "::EX yc2rgb(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! yc2rgb()" << endl;
	return FALSE;
}

BOOL __cdecl dlg_get_load_name(LPSTR name, LPSTR filter, LPSTR def)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->dlg_get_load_name){
			logout << clk << enter << af.name << "::EX dlg_get_load_name()" << endl;
			BOOL ret = af.exfunc->dlg_get_load_name(name, filter, def);
			logout << clk << leave << af.name << "::EX dlg_get_load_name(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! dlg_get_load_name()" << endl;
	return FALSE;
}

BOOL __cdecl dlg_get_save_name(LPSTR name, LPSTR filter, LPSTR def)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->dlg_get_save_name){
			logout << clk << enter << af.name << "::EX dlg_get_save_name()" << endl;
			BOOL ret = af.exfunc->dlg_get_save_name(name, filter, def);
			logout << clk << leave << af.name << "::EX dlg_get_save_name(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! dlg_get_save_name()" << endl;
	return FALSE;
}

int __cdecl ini_load_int(void *fp, LPSTR key, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->ini_load_int){
			logout << clk << enter << af.name << "::EX ini_load_int()" << endl;
			int ret = af.exfunc->ini_load_int(fp, key, n);
			logout << clk << leave << af.name << "::EX ini_load_int(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! ini_load_int()" << endl;
	return 0;
}

int __cdecl ini_save_int(void *fp, LPSTR key, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->ini_save_int){
			logout << clk << enter << af.name << "::EX ini_save_int()" << endl;
			int ret = af.exfunc->ini_save_int(fp, key, n);
			logout << clk << leave << af.name << "::EX ini_save_int(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! ini_save_int()" << endl;
	return 0;
}

BOOL __cdecl ini_load_str(void *fp, LPSTR key, LPSTR str, LPSTR def)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->ini_load_str){
			logout << clk << enter << af.name << "::EX ini_load_str()" << endl;
			BOOL ret = af.exfunc->ini_load_str(fp, key, str, def);
			logout << clk << leave << af.name << "::EX ini_load_str(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! ini_load_str()" << endl;
	return FALSE;
}

BOOL __cdecl ini_save_str(void *fp, LPSTR key, LPSTR str)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->ini_save_str){
			logout << clk << enter << af.name << "::EX ini_save_str()" << endl;
			BOOL ret = af.exfunc->ini_save_str(fp, key, str);
			logout << clk << leave << af.name << "::EX ini_save_str(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! ini_save_str()" << endl;
	return FALSE;
}

BOOL __cdecl get_source_file_info(void *editp, FILE_INFO *fip, int source_file_id)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_source_file_info){
			logout << clk << enter << af.name << "::EX get_source_file_info()" << endl;
			BOOL ret = af.exfunc->get_source_file_info(editp, fip, source_file_id);
			logout << clk << leave << af.name << "::EX get_source_file_info(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_source_file_info()" << endl;
	return FALSE;
}

BOOL __cdecl get_source_video_number(void *editp, int n, int *source_file_id, int *source_video_number)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_source_video_number){
			logout << clk << enter << af.name << "::EX get_source_video_number()" << endl;
			BOOL ret = af.exfunc->get_source_video_number(editp, n, source_file_id, source_video_number);
			logout << clk << leave << af.name << "::EX get_source_video_number(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_source_video_number()" << endl;
	return FALSE;
}

BOOL __cdecl get_sys_info(void *editp, SYS_INFO *sip)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_sys_info){
			logout << clk << enter << af.name << "::EX get_sys_info()" << endl;
			BOOL ret = af.exfunc->get_sys_info(editp, sip);
			logout << clk << leave << af.name << "::EX get_sys_info(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_sys_info()" << endl;
	return FALSE;
}

void * __cdecl get_filterp(int filter_id)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_filterp){
			logout << clk << enter << af.name << "::EX get_filterp()" << endl;
			void *ret = af.exfunc->get_filterp(filter_id);
			logout << clk << leave << af.name << "::EX get_filterp(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_filterp()" << endl;
	return NULL;
}

void * __cdecl get_ycp_filtering(void *fp, void *editp, int n, void *reserve)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_ycp_filtering){
			logout << clk << enter << af.name << "::EX get_ycp_filtering("
				<< "fp=0x" << fp << ",editp=0x" << editp << ",n=" << n << ")" << endl;
			void *ret = af.exfunc->get_ycp_filtering(fp, editp, n, reserve);
			logout << clk << leave << af.name << "::EX get_ycp_filtering(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX get_ycp_filtering()" << endl;
	}else{
		logout << clk << "FAILED!! get_ycp_filtering()" << endl;
	}
	return NULL;
}

int __cdecl get_audio_filtering(void *fp, void *editp, int n, void *buf)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_audio_filtering){
			logout << clk << enter << af.name << "::EX get_audio_filtering()" << endl;
			int ret = af.exfunc->get_audio_filtering(fp, editp, n, buf);
			logout << clk << leave << af.name << "::EX get_audio_filtering(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX get_audio_filtering()" << endl;
	}else{
		logout << clk << "FAILED!! get_audio_filtering()" << endl;
	}
	return 0;
}

BOOL __cdecl set_ycp_filtering_cache_size(void *fp, int w, int h, int d, int flag)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->set_ycp_filtering_cache_size){
			logout << clk << enter << af.name << "::EX set_ycp_filtering_cache_size("
				<< "fp=0x" << fp << ",w=" << w << ",h=" << h << ",d=" << d << ",flag=" << flag << ")" << endl;
			BOOL ret = af.exfunc->set_ycp_filtering_cache_size(fp, w, h, d, flag);
			logout << clk << leave << af.name << "::EX set_ycp_filtering_cache_size(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX set_ycp_filtering_cache_size()" << endl;
	}else{
		logout << clk << "FAILED!! set_ycp_filtering_cache_size()" << endl;
	}
	return FALSE;
}

void * __cdecl get_ycp_filtering_cache(void *fp, void *editp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_ycp_filtering_cache){
			logout << clk << enter << af.name << "::EX get_ycp_filtering_cache("
				<< "fp=0x" << fp << ",editp=0x" << editp << ",n=" << n << ")" << endl;
			void *ret = af.exfunc->get_ycp_filtering_cache(fp, editp, n);
			logout << clk << leave << af.name << "::EX get_ycp_filtering_cache(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX get_ycp_filtering_cache()" << endl;
	}else{
		logout << clk << "FAILED!! get_ycp_filtering_cache()" << endl;
	}
	return NULL;
}

void * __cdecl get_ycp_source_cache(void *editp, int n, int ofs)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_ycp_source_cache){
			logout << clk << enter << af.name << "::EX get_ycp_source_cache("
				<< "editp=0x" << editp << ",n=" << n << ",ofs=" << ofs << ")" << endl;
			void * ret = af.exfunc->get_ycp_source_cache(editp, n, ofs);
			logout << clk << leave << af.name << "::EX get_ycp_source_cache(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_ycp_source_cache()" << endl;
	return NULL;
}

void * __cdecl get_disp_pixelp(void *editp, DWORD format)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_disp_pixelp){
			logout << clk << enter << af.name << "::EX get_disp_pixelp()" << endl;
			void * ret = af.exfunc->get_disp_pixelp(editp, format);
			logout << clk << leave << af.name << "::EX get_disp_pixelp(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_disp_pixelp()" << endl;
	return NULL;
}

BOOL __cdecl get_pixel_source(void *editp, int n, void *pixelp, DWORD format)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_pixel_source){
			logout << clk << enter << af.name << "::EX get_pixel_source()" << endl;
			BOOL ret = af.exfunc->get_pixel_source(editp, n, pixelp, format);
			logout << clk << leave << af.name << "::EX get_pixel_source(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_pixel_source()" << endl;
	return FALSE;
}

BOOL __cdecl get_pixel_filtered_ex(void *editp, int n, void *pixelp, int *w, int *h, DWORD format)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_pixel_filtered_ex){
			logout << clk << enter << af.name << "::EX get_pixel_filtered_ex()" << endl;
			BOOL ret = af.exfunc->get_pixel_filtered_ex(editp, n, pixelp, w, h, format);
			logout << clk << leave << af.name << "::EX get_pixel_filtered_ex(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_pixel_filtered_ex()" << endl;
	return FALSE;
}

PIXEL_YC * __cdecl get_ycp_filtering_cache_ex(void *fp, void *editp, int n, int *w, int *h)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_ycp_filtering_cache_ex){
			logout << clk << enter << af.name << "::EX get_ycp_filtering_cache_ex("
				<< "fp=0x" << fp << ",editp=0x" << editp << ",n=" << n << ")" << endl;
			PIXEL_YC *ret = af.exfunc->get_ycp_filtering_cache_ex(fp, editp, n, w, h);
			logout << clk << leave << af.name << "::EX get_ycp_filtering_cache_ex(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	if(fp){
		ATFilter *pf = static_cast<ATFilter*>(fp);
		logout << clk << "FAILED!! " << pf->name << "::EX get_ycp_filtering_cache_ex()" << endl;
	}else{
		logout << clk << "FAILED!! get_ycp_filtering_cache_ex()" << endl;
	}
	return NULL;
}

BOOL __cdecl exec_multi_thread_func(MULTI_THREAD_FUNC func, void *param1, void *param2)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->exec_multi_thread_func){
			logout << clk << enter << af.name << "::EX exec_multi_thread_func()" << endl;
			BOOL ret = af.exfunc->exec_multi_thread_func(func, param1, param2);
			logout << clk << leave << af.name << "::EX exec_multi_thread_func(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! exec_multi_thread_func()" << endl;
	return FALSE;
}

PIXEL_YC * __cdecl create_yc(void)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->create_yc){
			logout << clk << enter << af.name << "::EX create_yc()" << endl;
			PIXEL_YC *ret = af.exfunc->create_yc();
			logout << clk << leave << af.name << "::EX create_yc(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! create_yc()" << endl;
	return NULL;
}

void __cdecl delete_yc(PIXEL_YC *ycp)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->delete_yc){
			logout << clk << enter << af.name << "::EX delete_yc()" << endl;
			af.exfunc->delete_yc(ycp);
			logout << clk << leave << af.name << "::EX delete_yc()" << endl;
			return;
		}
	}
	logout << clk << "FAILED!! delete_yc()" << endl;
}

BOOL __cdecl load_image(PIXEL_YC *ycp, LPSTR file, int *w, int *h, int flag)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->load_image){
			logout << clk << enter << af.name << "::EX load_image()" << endl;
			BOOL ret = af.exfunc->load_image(ycp, file, w, h, flag);
			logout << clk << leave << af.name << "::EX load_image(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! load_image()" << endl;
	return FALSE;
}

void __cdecl resize_yc(PIXEL_YC *ycp, int w, int h, PIXEL_YC *ycp_src, int sx, int sy, int sw, int sh)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->resize_yc){
			logout << clk << enter << af.name << "::EX resize_yc()" << endl;
			af.exfunc->resize_yc(ycp, w, h, ycp_src, sx, sy, sw, sh);
			logout << clk << leave << af.name << "::EX resize_yc()" << endl;
			return;
		}
	}
	logout << clk << "FAILED!! resize_yc()" << endl;
}

void __cdecl copy_yc(PIXEL_YC *ycp, int x, int y, PIXEL_YC *ycp_src, int sx, int sy, int sw, int sh, int tr)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->copy_yc){
			logout << clk << enter << af.name << "::EX copy_yc()" << endl;
			af.exfunc->copy_yc(ycp, x, y, ycp_src, sx, sy, sw, sh, tr);
			logout << clk << leave << af.name << "::EX copy_yc()" << endl;
			return;
		}
	}
	logout << clk << "FAILED!! copy_yc()" << endl;
}

void __cdecl draw_text(PIXEL_YC *ycp, int x, int y, LPSTR text, int r, int g, int b, int tr, HFONT hfont, int *w, int *h)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->draw_text){
			logout << clk << enter << af.name << "::EX draw_text()" << endl;
			af.exfunc->draw_text(ycp, x, y, text, r, g, b, tr, hfont, w, h);
			logout << clk << leave << af.name << "::EX draw_text()" << endl;
			return;
		}
	}
	logout << clk << "FAILED!! draw_text()" << endl;
}

AVI_FILE_HANDLE __cdecl avi_file_open(LPSTR file, FILE_INFO *fip, int flag)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->avi_file_open){
			logout << clk << enter << af.name << "::EX avi_file_open()" << endl;
			AVI_FILE_HANDLE ret = af.exfunc->avi_file_open(file, fip, flag);
			logout << clk << leave << af.name << "::EX avi_file_open(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! avi_file_open()" << endl;
	return NULL;
}

void __cdecl avi_file_close(AVI_FILE_HANDLE afh)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->avi_file_close){
			logout << clk << enter << af.name << "::EX avi_file_close()" << endl;
			af.exfunc->avi_file_close(afh);
			logout << clk << leave << af.name << "::EX avi_file_close()" << endl;
			return;
		}
	}
	logout << clk << "FAILED!! avi_file_close()" << endl;
}

BOOL __cdecl avi_file_read_video(AVI_FILE_HANDLE afh, PIXEL_YC *ycp, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->avi_file_read_video){
			logout << clk << enter << af.name << "::EX avi_file_read_video()" << endl;
			BOOL ret = af.exfunc->avi_file_read_video(afh, ycp, n);
			logout << clk << leave << af.name << "::EX avi_file_read_video(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! avi_file_read_video()" << endl;
	return FALSE;
}

int __cdecl avi_file_read_audio(AVI_FILE_HANDLE afh, void *buf, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->avi_file_read_audio){
			logout << clk << enter << af.name << "::EX avi_file_read_audio()" << endl;
			int ret = af.exfunc->avi_file_read_audio(afh, buf, n);
			logout << clk << leave << af.name << "::EX avi_file_read_audio(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! avi_file_read_audio()" << endl;
	return 0;
}

void * __cdecl avi_file_get_video_pixelp(AVI_FILE_HANDLE afh, int n)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->avi_file_get_video_pixelp){
			logout << clk << enter << af.name << "::EX avi_file_get_video_pixelp()" << endl;
			void * ret = af.exfunc->avi_file_get_video_pixelp(afh, n);
			logout << clk << leave << af.name << "::EX avi_file_get_video_pixelp(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! avi_file_get_video_pixelp()" << endl;
	return NULL;
}

LPSTR __cdecl get_avi_file_filter(int type)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_avi_file_filter){
			logout << clk << enter << af.name << "::EX get_avi_file_filter()" << endl;
			LPSTR ret = af.exfunc->get_avi_file_filter(type);
			logout << clk << leave << af.name << "::EX get_avi_file_filter(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_avi_file_filter()" << endl;
	return NULL;
}

int __cdecl avi_file_read_audio_sample(AVI_FILE_HANDLE afh, int start, int length, void *buf)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->avi_file_read_audio_sample){
			logout << clk << enter << af.name << "::EX avi_file_read_audio_sample()" << endl;
			int ret = af.exfunc->avi_file_read_audio_sample(afh, start, length, buf);
			logout << clk << leave << af.name << "::EX avi_file_read_audio_sample(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! avi_file_read_audio_sample()" << endl;
	return 0;
}

int __cdecl avi_file_set_audio_sample_rate(AVI_FILE_HANDLE afh, int audio_rate, int audio_ch)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->avi_file_set_audio_sample_rate){
			logout << clk << enter << af.name << "::EX avi_file_set_audio_sample_rate()" << endl;
			int ret = af.exfunc->avi_file_set_audio_sample_rate(afh, audio_rate, audio_ch);
			logout << clk << leave << af.name << "::EX avi_file_set_audio_sample_rate(ret=" << ret << ")" << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! avi_file_set_audio_sample_rate()" << endl;
	return 0;
}

BYTE * __cdecl get_frame_status_table(void *editp, int type)
{
	ATFWrap* aw = fhook.GetStackTop();
	if(aw != NULL){
		const ATFilter &af = aw->GetOriginalFilter();
		if(af.exfunc->get_frame_status_table){
			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame_status_table(editp=0x%p,type=%d)", af.name, editp, type);
			logout << clk << enter << strbuf << endl;

			BYTE * ret = af.exfunc->get_frame_status_table(editp, type);

			sprintf_s(strbuf, sizeof(strbuf),
				"%s::EX get_frame_status_table(ret=0x%p)", af.name, ret);
			logout << clk << leave << strbuf << endl;
			return ret;
		}
	}
	logout << clk << "FAILED!! get_frame_status_table()" << endl;
	return 0;
}

//exfunc table
EXFUNC FilterHook::ExFuncTbl = {
	get_ycp_ofs,
	get_ycp,
	get_pixelp,
	get_audio,
	is_editing,
	is_saving,
	get_frame,
	get_frame_n,
	get_frame_size,
	set_frame,
	set_frame_n,
	copy_frame,
	copy_video,
	copy_audio,
	copy_clip,
	paste_clip,
	get_frame_status,
	set_frame_status,
	is_saveframe,
	is_keyframe,
	is_recompress,
	filter_window_update,
	is_filter_window_disp,
	get_file_info,
	get_config_name,
	is_filter_active,
	get_pixel_filtered,
	get_audio_filtered,
	get_select_frame,
	set_select_frame,
	rgb2yc,
	yc2rgb,
	dlg_get_load_name,
	dlg_get_save_name,
	ini_load_int,
	ini_save_int,
	ini_load_str,
	ini_save_str,
	get_source_file_info,
	get_source_video_number,
	get_sys_info,
	get_filterp,
	get_ycp_filtering,
	get_audio_filtering,
	set_ycp_filtering_cache_size,
	get_ycp_filtering_cache,
	get_ycp_source_cache,
	get_disp_pixelp,
	get_pixel_source,
	get_pixel_filtered_ex,
	get_ycp_filtering_cache_ex,
	exec_multi_thread_func,
	create_yc,
	delete_yc,
	load_image,
	resize_yc,
	copy_yc,
	draw_text,
	avi_file_open,
	avi_file_close,
	avi_file_read_video,
	avi_file_read_audio,
	avi_file_get_video_pixelp,
	get_avi_file_filter,
	avi_file_read_audio_sample,
	avi_file_set_audio_sample_rate,
	get_frame_status_table,
};

